#include "camera.h"

#include <GL/glut.h>
#include "robot.h"


float frustum[6] = { -0.45, 0.45, -0.45, 0.45, 1, 100 };


float eyeX = 0;
float eyeY = 0;
float eyeZ = 20;
float upX  = 0;
float upY  = 1;
float upZ  = 0;


float camera_pitch      = 0;
float camera_theta      = 0;
float camera_zoom       = 0;
int   camera_mode       = C_THIRD;


void position_camera ()
{
  glMatrixMode(GL_PROJECTION);
  glPopMatrix();
  glPushMatrix();

  if (camera_mode == C_THIRD)
  {
      gluLookAt(eyeX, eyeY, eyeZ, 0, 0, 0, upX, upY, upZ);

      glTranslatef(eyeX * camera_zoom,
                   eyeY * camera_zoom,
                   eyeZ * camera_zoom);
      glRotatef(camera_pitch, 1, 0, 0);
      glRotatef(camera_theta, 0, 0, 1);
  }
  else if (camera_mode == C_FIRST)
  {
      gluLookAt(0, 0, 0, 1, 0, 0, 0, 0, 1);

      glTranslatef(0, 0, -0.5);
      glRotatef(robot_head_pitch, 0, 1, 0);
      glRotatef(-robot_head_theta, 0, 0, 1);
      glTranslatef(0, 0, -2.8);
      glRotatef(-robot_body_theta, 0, 0, 1);
      glTranslatef(-robot_body_x, -robot_body_y, -robot_body_z);
  }
}

